import java.io.*;
import java.lang.*;

public class IOExample {

  public static void main (String [] args) {
    StreamTokenizer st = new StreamTokenizer
		             (new InputStreamReader (System.in));
    try {
      for (;;) {
	int t = st.nextToken ();
	try {
	  switch (t) {
	  case StreamTokenizer.TT_EOF: throw new EOFException ();
	  case StreamTokenizer.TT_EOL: break;
	  case StreamTokenizer.TT_NUMBER:
	    System.out.println ("Number = " + (int) st.nval);
	    break;
	  case StreamTokenizer.TT_WORD:
	    System.out.println ("Word = " + st.sval);
	    break;
	  default:
	    System.out.println ("Character = '" + (char) t + "'");
	    break;
	  };
	}
	catch (NumberFormatException e) {
	  System.out.println ("Format error: " + e.getMessage ());
	};
      };
    }
    catch (EOFException e) {
      System.out.println ("End of file");
    }
    catch (IOException e) {
      System.out.println ("IO exception: " + e.getMessage ());
    };
  };

}
